//=============================================================================
//  Unified IO - C++ interface for industrial IO cards
//  Copyright (C) 2000, UAB "BBD SOFT" ( http://www.bbdsoft.com/ )
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
//  The author of this program may be contacted at developers@bbdsoft.com
//=============================================================================


#ifndef _BTRACE_
   #include "btrace.hpp"
#endif

#ifndef _IOPORT_
   #include "ioport.hpp"
#endif

#include <conio.h>

using namespace Uniio;

//-----------------------------------------------------------------------------
IOPort::IOPort ( const unsigned inPortNumber
               , const bool fWriteAccess
               )
   : thePortNumber ( inPortNumber )
   , theWriteAccess ( fWriteAccess )
{
BFUNCTRACE_DEVELOP ();

} // end constructor


//-----------------------------------------------------------------------------
IOPort::~IOPort ()
{
BFUNCTRACE_DEVELOP ();
} // end destructor


//-----------------------------------------------------------------------------
IOPort & IOPort::writeChar ( const char inValue )
{
BFUNCTRACE_DEVELOP ();
BASSERTTEXT (theWriteAccess, "Write access is not enabled on this port");

_outp ( thePortNumber, inValue);

return * this;
} // end IOPort::write (..)


//-----------------------------------------------------------------------------
IOPort & IOPort::writeShort ( const short inValue )
{
BFUNCTRACE_DEVELOP ();
BASSERTTEXT (theWriteAccess, "Write access is not enabled on this port");

_outpw ( thePortNumber, inValue);

return * this;
} // end IOPort::write (..)


//-----------------------------------------------------------------------------
IOPort & IOPort::writeLong ( const long inValue )
{
BFUNCTRACE_DEVELOP ();
BASSERTTEXT (theWriteAccess, "Write access is not enabled on this port");

_outpd ( thePortNumber, inValue);

return * this;
} // end IOPort::write (..)


//-----------------------------------------------------------------------------
char IOPort::readChar () const
{
BFUNCTRACE_DEVELOP ();

return _inp (thePortNumber);
} // end IOPort::readChar () const


//-----------------------------------------------------------------------------
short IOPort::readShort () const
{
BFUNCTRACE_DEVELOP ();

return _inpw (thePortNumber);
} // end IOPort::readShort () const


//-----------------------------------------------------------------------------
long IOPort::readLong () const
{
BFUNCTRACE_DEVELOP ();

return _inpd (thePortNumber);
} // end IOPort::readLong () const
